<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:13 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>CppComponent (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="CppComponent (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/language/cpp/CppBinary.html" title="interface in org.gradle.language.cpp"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/language/cpp/CppExecutable.html" title="interface in org.gradle.language.cpp"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/language/cpp/CppComponent.html" target="_top">Frames</a></li>
<li><a href="CppComponent.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.language.cpp</div>
<h2 title="Interface CppComponent" class="title">Interface CppComponent</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Superinterfaces:</dt>
<dd><a href="../../../../org/gradle/api/Named.html" title="interface in org.gradle.api">Named</a>, <a href="../../../../org/gradle/api/component/SoftwareComponent.html" title="interface in org.gradle.api.component">SoftwareComponent</a></dd>
</dl>
<dl>
<dt>All Known Subinterfaces:</dt>
<dd><a href="../../../../org/gradle/language/cpp/CppApplication.html" title="interface in org.gradle.language.cpp">CppApplication</a>, <a href="../../../../org/gradle/language/cpp/CppLibrary.html" title="interface in org.gradle.language.cpp">CppLibrary</a></dd>
</dl>
<hr>
<br>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
public interface <span class="strong">CppComponent</span>
extends <a href="../../../../org/gradle/api/component/SoftwareComponent.html" title="interface in org.gradle.api.component">SoftwareComponent</a></pre>
<div class="block">Configuration for a C++ component, such as a library or executable, defining the source files and private header directories that make up the component. Private headers are those that are visible only to the source files of the component.

 <p>A C++ component is composed of some C++ source files that are compiled and then linked into some binary.</p>

 <p>An instance of this type is added as a project extension by the C++ plugins.</p></div>
<dl><dt><span class="strong">Since:</span></dt>
  <dd>4.2</dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="nested_class_summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<ul class="blockList">
<li class="blockList"><a name="nested_classes_inherited_from_class_org.gradle.api.Named">
<!--   -->
</a>
<h3>Nested classes/interfaces inherited from interface&nbsp;org.gradle.api.<a href="../../../../org/gradle/api/Named.html" title="interface in org.gradle.api">Named</a></h3>
<code><a href="../../../../org/gradle/api/Named.Namer.html" title="class in org.gradle.api">Named.Namer</a></code></li>
</ul>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/provider/PropertyState.html" title="interface in org.gradle.api.provider">PropertyState</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/language/cpp/CppComponent.html#getBaseName()">getBaseName</a></strong>()</code>
<div class="block">Specifies the base name for this component.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/FileCollection.html" title="interface in org.gradle.api.file">FileCollection</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/language/cpp/CppComponent.html#getCppSource()">getCppSource</a></strong>()</code>
<div class="block">Returns the C++ source files of this component, as defined in <a href="../../../../org/gradle/language/cpp/CppComponent.html#getSource()"><code>getSource()</code></a>.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/language/cpp/CppBinary.html" title="interface in org.gradle.language.cpp">CppBinary</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/language/cpp/CppComponent.html#getDevelopmentBinary()">getDevelopmentBinary</a></strong>()</code>
<div class="block">Returns the binary of the component to use as the default for development.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/FileTree.html" title="interface in org.gradle.api.file">FileTree</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/language/cpp/CppComponent.html#getHeaderFiles()">getHeaderFiles</a></strong>()</code>
<div class="block">Returns all header files of this component.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/artifacts/Configuration.html" title="interface in org.gradle.api.artifacts">Configuration</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/language/cpp/CppComponent.html#getImplementationDependencies()">getImplementationDependencies</a></strong>()</code>
<div class="block">Returns the implementation dependencies of this component.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/FileCollection.html" title="interface in org.gradle.api.file">FileCollection</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/language/cpp/CppComponent.html#getPrivateHeaderDirs()">getPrivateHeaderDirs</a></strong>()</code>
<div class="block">Returns the private header files of this component, as defined in <a href="../../../../org/gradle/language/cpp/CppComponent.html#getPrivateHeaders()"><code>getPrivateHeaders()</code></a>.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/ConfigurableFileCollection.html" title="interface in org.gradle.api.file">ConfigurableFileCollection</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/language/cpp/CppComponent.html#getPrivateHeaders()">getPrivateHeaders</a></strong>()</code>
<div class="block">Defines the private header file directories of this library.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/file/ConfigurableFileCollection.html" title="interface in org.gradle.api.file">ConfigurableFileCollection</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/language/cpp/CppComponent.html#getSource()">getSource</a></strong>()</code>
<div class="block">Defines the source files or directories of this component.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/language/cpp/CppComponent.html#privateHeaders(org.gradle.api.Action)">privateHeaders</a></strong>(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/ConfigurableFileCollection.html" title="interface in org.gradle.api.file">ConfigurableFileCollection</a>&gt;&nbsp;action)</code>
<div class="block">Configures the private header directories for this component.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/language/cpp/CppComponent.html#source(org.gradle.api.Action)">source</a></strong>(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/ConfigurableFileCollection.html" title="interface in org.gradle.api.file">ConfigurableFileCollection</a>&gt;&nbsp;action)</code>
<div class="block">Configures the source files or directories for this component.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_org.gradle.api.Named">
<!--   -->
</a>
<h3>Methods inherited from interface&nbsp;org.gradle.api.<a href="../../../../org/gradle/api/Named.html" title="interface in org.gradle.api">Named</a></h3>
<code><a href="../../../../org/gradle/api/Named.html#getName()">getName</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getBaseName()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getBaseName</h4>
<pre><a href="../../../../org/gradle/api/provider/PropertyState.html" title="interface in org.gradle.api.provider">PropertyState</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;getBaseName()</pre>
<div class="block">Specifies the base name for this component. This name is used to calculate various output file names. The default value is calculated from the project name.</div>
</li>
</ul>
<a name="getSource()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSource</h4>
<pre><a href="../../../../org/gradle/api/file/ConfigurableFileCollection.html" title="interface in org.gradle.api.file">ConfigurableFileCollection</a>&nbsp;getSource()</pre>
<div class="block">Defines the source files or directories of this component. You can add files or directories to this collection. When a directory is added, all source files are included for compilation.

 <p>When this collection is empty, the directory <code>src/main/cpp</code> is used by default.</p></div>
</li>
</ul>
<a name="source(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>source</h4>
<pre>void&nbsp;source(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/ConfigurableFileCollection.html" title="interface in org.gradle.api.file">ConfigurableFileCollection</a>&gt;&nbsp;action)</pre>
<div class="block">Configures the source files or directories for this component.</div>
</li>
</ul>
<a name="getCppSource()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getCppSource</h4>
<pre><a href="../../../../org/gradle/api/file/FileCollection.html" title="interface in org.gradle.api.file">FileCollection</a>&nbsp;getCppSource()</pre>
<div class="block">Returns the C++ source files of this component, as defined in <a href="../../../../org/gradle/language/cpp/CppComponent.html#getSource()"><code>getSource()</code></a>.</div>
</li>
</ul>
<a name="getPrivateHeaders()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPrivateHeaders</h4>
<pre><a href="../../../../org/gradle/api/file/ConfigurableFileCollection.html" title="interface in org.gradle.api.file">ConfigurableFileCollection</a>&nbsp;getPrivateHeaders()</pre>
<div class="block">Defines the private header file directories of this library.

 <p>When this collection is empty, the directory <code>src/main/headers</code> is used by default.</p></div>
</li>
</ul>
<a name="privateHeaders(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>privateHeaders</h4>
<pre>void&nbsp;privateHeaders(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/file/ConfigurableFileCollection.html" title="interface in org.gradle.api.file">ConfigurableFileCollection</a>&gt;&nbsp;action)</pre>
<div class="block">Configures the private header directories for this component.</div>
</li>
</ul>
<a name="getPrivateHeaderDirs()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPrivateHeaderDirs</h4>
<pre><a href="../../../../org/gradle/api/file/FileCollection.html" title="interface in org.gradle.api.file">FileCollection</a>&nbsp;getPrivateHeaderDirs()</pre>
<div class="block">Returns the private header files of this component, as defined in <a href="../../../../org/gradle/language/cpp/CppComponent.html#getPrivateHeaders()"><code>getPrivateHeaders()</code></a>.</div>
</li>
</ul>
<a name="getHeaderFiles()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getHeaderFiles</h4>
<pre><a href="../../../../org/gradle/api/file/FileTree.html" title="interface in org.gradle.api.file">FileTree</a>&nbsp;getHeaderFiles()</pre>
<div class="block">Returns all header files of this component. Includes public and private header files.</div>
</li>
</ul>
<a name="getImplementationDependencies()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getImplementationDependencies</h4>
<pre><a href="../../../../org/gradle/api/artifacts/Configuration.html" title="interface in org.gradle.api.artifacts">Configuration</a>&nbsp;getImplementationDependencies()</pre>
<div class="block">Returns the implementation dependencies of this component.</div>
</li>
</ul>
<a name="getDevelopmentBinary()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getDevelopmentBinary</h4>
<pre><a href="../../../../org/gradle/language/cpp/CppBinary.html" title="interface in org.gradle.language.cpp">CppBinary</a>&nbsp;getDevelopmentBinary()</pre>
<div class="block">Returns the binary of the component to use as the default for development.</div>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/language/cpp/CppBinary.html" title="interface in org.gradle.language.cpp"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/language/cpp/CppExecutable.html" title="interface in org.gradle.language.cpp"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/language/cpp/CppComponent.html" target="_top">Frames</a></li>
<li><a href="CppComponent.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
